#ifndef _KMOD_PROTECT_H
#define	_KMOD_PROTECT_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <linux/limits.h>

#ifdef __cplusplus
extern "C" {
#endif

/*
 * 功能：通过ko文件名获取对应模块的名字
 * ko_file: 可以是单个的ko文件名，也可以是全路径的ko文件
 * 返回值：成功时返回"char *"类型的模块名（需要free释放），失败或文件名格式不对时返回NULL
 */
char *get_kmod_name_from_ko(const char *ko_file);

/*
 * 功能：添加需要保护的模块名到模块保护列表文件中
 * kmod_name: 是模块名
 */
int add_to_kmod_protect(char *ko_file);

/*
 * 功能：从模块保护列表文件中移除不需要保护的模块
 * kmod_name: 是模块名
 */
int remove_from_kmod_protect(char *ko_file);

#ifdef __cplusplus
}
#endif

#endif
